--[[ =================================================================
    Version 1.0
	
	Release:
		March 25, 2016
	
	Author:
		Zurom-Firetree
	
	Description:
        Gold Tracker Plus is a tool that provides extensive gold
		tracking capabilities. Allowing users to track gold across
		multiple categories and timelines, Gold Tracker Plus provides
		the most indepth gold accumulation data than any other addon!

    Contact:
        For questions, bug reports visit the website or send an email
        to the following address: fleury24@gmail.com

    Dependencies:
        None

    Credits:
        A big 'Thank You' to all the people at Blizzard Entertainment
        for making World of Warcraft.
    ================================================================= --]]

local GT_AddonName,GT_Globals = ...;
local GT_Version = GetAddOnMetadata(GT_AddonName, "Version");

-- String Vars
local plName,curMonth,curDay,curYear,trackType = '','','','','solo';
--local curGold,curSilver,curCopper = 0,0,0;
-- Integer Vars
local weekday,month,day,year = 0,0,0,0;
local curMoney,newMoney = 0,0,0;
local newGold,newSilver,newCopper = 0,0,0;
local newWeekday,newMonth,newWeek,newYear = 0,0,0,0;

-- Boolean Vars
local isTracking,isQuest,isVendor,isPurchase,isRepair = false,false,false,false,false;
local isWeekA,isWeekB,weekChange = false,false,false;

-- Merchant Vars
local SpendTotal,GainTotal,RepairTotal = 0,0,0;
--Frame Vars

-- Frame Vars
local WorldDayFrameText,WorldWeekFrameText,WorldMonthFrameText,WorldYearFrameText = nil,nil,nil,nil;
local InstanceDayFrameText,InstanceWeekFrameText,InstanceMonthFrameText,InstanceYearFrameText = nil,nil,nil,nil;
local QuestDayFrameText, QuestWeekFrameText,QuestMonthFrameText,QuestYearFrameText = nil,nil,nil,nil;
local VendorDayFrameText,VendorWeekFrameText,VendorMonthFrameText,VendorYearFrameText = nil,nil,nil,nil;
local SpentDayFrameText,SpentWeekFrameText,SpentMonthFrameText,SpentYearFrameText = nil,nil,nil,nil;
local RepairDayFrameText,RepairWeekFrameText,epairMonthFrameText,RepairYearFrameText = nil,nil,nil,nil;
	
local AllTimeWorldFrameText,AllTimeInstanceFrameText,AllTimeQuestFrameText,AllTimeVendorFrameText,AllTimeSpentFrameText,AllTimeRepairFrameText = nil,nil,nil,nil,nil,nil;
local AllTimeIncomeTotalFrameText,AllTimeExpenseTotalFrameText = nil,nil;
	
GT_Globals.Events = CreateFrame("Frame");
GT_Globals.GoldDialog = CreateFrame("Frame","GoldTrackerDialog",UIParent);
GT_Globals.ArchiveDialog = CreateFrame("Frame","ArchiveDialog",UIParent);
local GoldDialog = GT_Globals.GoldDialog;
local ArchiveDialog = GT_Globals.ArchiveDialog;
local Events = GT_Globals.Events;

Events:RegisterEvent("ADDON_LOADED");
Events:RegisterEvent("PLAYER_ENTERING_WORLD");
Events:RegisterEvent("PLAYER_ALIVE");
Events:RegisterEvent("LOOT_OPENED");
Events:RegisterEvent("CHAT_MSG_MONEY");
Events:RegisterEvent("QUEST_COMPLETE");
Events:RegisterEvent("MERCHANT_SHOW");
Events:RegisterEvent("CHAT_MSG_SYSTEM");

-- Table Vars
local weekdays = {};
local months = {};

local GT_OptionDropDownMenu = CreateFrame("Frame", "GT_OptionDropDownMenu");
GT_OptionDropDownMenu.displayMode = "MENU";
--GT_OptionDropDownMenu.initialize = function(self,level) end;
GT_OptionDropDownMenu.info = {};
GT_OptionDropDownMenu.UncheckHack = function(dropdownbutton)
	print("Name: '"..dropdownbutton:GetName().."check".."'");
	_G[dropdownbutton:GetName().."Check"]:Hide();
end
GT_OptionDropDownMenu.HideMenu = function()
	if UIDROPDOWNMENU_OPEN_MENU == GT_OptionDropDownMenu then
		CloseDropDownMenus();
	end
end
GT_Globals.Archives = CreateFrame("Button","ArchiveButton",GoldDialog);
	--GT_Globals.Archives:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 7});
	GT_Globals.Archives:SetHeight(20); -- 180 when upper group frame hidden
	GT_Globals.Archives:SetWidth(75);
	GT_Globals.Archives:SetPoint("TOPRIGHT",-25,-5);
	GT_Globals.Archives:SetFrameStrata("DIALOG");
	GT_Globals.Archives:Show();
	
	-- ARCHIVE BUTTON LABEL
	local ArchiveButtonLabel = CreateFrame("Frame",nil,GT_Globals.Archives);
	ArchiveButtonLabel:SetPoint("TOP",0,-2);
	ArchiveButtonLabel:SetWidth(50);
	ArchiveButtonLabel:SetHeight(20);
	GT_Globals.ArchiveButtonLabel = ArchiveButtonLabel:CreateFontString(nil, "BACKGROUND", "GameFontNormal");
	local ArchiveButtonLabelText = GT_Globals.ArchiveButtonLabel
	ArchiveButtonLabelText:SetPoint("TOP",0,-2);
	ArchiveButtonLabelText:SetFont("Fonts\\FRIZQT__.TTF", 11);
	ArchiveButtonLabelText:SetTextColor(1,1,0,1);
	ArchiveButtonLabelText:SetJustifyH("LEFT");
	ArchiveButtonLabelText:SetText("Archives");
	
GT_Globals.Archives:SetScript("OnClick",function(self, button,down)
	if (button == "LeftButton") then
		ToggleDropDownMenu(1,nil,GT_OptionDropDownMenu,self:GetName(),0,0);
	end
end);
GT_Globals.Archives:RegisterForClicks("LeftButtonUp");
--GT_Globals.EventFrame = CreateFrame("Frame");
--GT_Globals.MainFrames = CreateFrame("Frame","GTMainFrame",UIParent);
--events = GT_Globals.EventFrame;

--main = GT_Globals.MainFrames;

--[[Events:RegisterEvent("ADDON_LOADED");
Events:RegisterEvent("PLAYER_ENTERING_WORLD");
Events:RegisterEvent("PLAYER_ALIVE");
Events:RegisterEvent("LOOT_OPENED");
Events:RegisterEvent("CHAT_MSG_MONEY");]]

local function InitializeVars()
	--Initialize Variables
	weekday,month,day,year = CalendarGetDate();
	plName = GetUnitName("player");
	
	weekdays[1] = "Sunday";
	weekdays[2] = "Monday";
	weekdays[3] = "Tuesday";
	weekdays[4] = "Wednesday";
	weekdays[5] = "Thursday";
	weekdays[6] = "Friday";
	weekdays[7] = "Saturday";
	
	months[1] = "January";
	months[2] = "February";
	months[3] = "March";
	months[4] = "April";
	months[5] = "May";
	months[6] = "June";
	months[7] = "July";
	months[8] = "August";
	months[9] = "September";
	months[10] = "October";
	months[11] = "November";
	months[12] = "December";
end

local function FormatArchiveValues(self,val)
	if (val == 0) then
		val = "0"
	else
		if (val < 100) then
			val = ("%dc"):format(val % 100);
		elseif (val < 10000) then
			val = ("%ds %dc"):format((val / 100) % 100, val % 100)
		else
			val = ("%dg %ds %dc"):format(val / 100 / 100, (val / 100) % 100, val % 100)
		end
	end
	
	self:SetText(val);
end

local function ShowArchives(ListYear,ListMonth)
	ArchiveDialog:Show();
	if (ListMonth == nil) then
		GT_Globals.ArchiveTitleLabel:SetText(tostring(ListYear));
		
		FormatArchiveValues(GT_Globals.ArchiveWorldFrame,GTr_SavedVars[tostring(plName)]["archive"][tostring(ListYear)]['world']);
		FormatArchiveValues(GT_Globals.ArchiveInstanceFrame,GTr_SavedVars[tostring(plName)]["archive"][tostring(ListYear)]['instance']);
		FormatArchiveValues(GT_Globals.ArchiveQuestFrame,GTr_SavedVars[tostring(plName)]["archive"][tostring(ListYear)]['quest']);
		FormatArchiveValues(GT_Globals.ArchiveVendorFrame,GTr_SavedVars[tostring(plName)]["archive"][tostring(ListYear)]['vendor']);
		FormatArchiveValues(GT_Globals.ArchiveSpentFrame,GTr_SavedVars[tostring(plName)]["archive"][tostring(ListYear)]['spent']);
		FormatArchiveValues(GT_Globals.ArchiveRepairFrame,GTr_SavedVars[tostring(plName)]["archive"][tostring(ListYear)]['repair']);
	else
		GT_Globals.ArchiveTitleLabel:SetText(tostring(ListMonth).." "..tostring(ListYear));
	
		FormatArchiveValues(GT_Globals.ArchiveWorldFrame,GTr_SavedVars[tostring(plName)]["archive"][tostring(ListYear)][tostring(ListMonth)]['world']);
		FormatArchiveValues(GT_Globals.ArchiveInstanceFrame,GTr_SavedVars[tostring(plName)]["archive"][tostring(ListYear)][tostring(ListMonth)]['instance']);
		FormatArchiveValues(GT_Globals.ArchiveQuestFrame,GTr_SavedVars[tostring(plName)]["archive"][tostring(ListYear)][tostring(ListMonth)]['quest']);
		FormatArchiveValues(GT_Globals.ArchiveVendorFrame,GTr_SavedVars[tostring(plName)]["archive"][tostring(ListYear)][tostring(ListMonth)]['vendor']);
		FormatArchiveValues(GT_Globals.ArchiveSpentFrame,GTr_SavedVars[tostring(plName)]["archive"][tostring(ListYear)][tostring(ListMonth)]['spent']);
		FormatArchiveValues(GT_Globals.ArchiveRepairFrame,GTr_SavedVars[tostring(plName)]["archive"][tostring(ListYear)][tostring(ListMonth)]['repair']);
	end

end

GT_OptionDropDownMenu.initialize = function(self,level)
	local isManyYears = false;
	local numYears = 1;
	local numMenuItems = 2;
	local ListYears = GTr_SavedVars[tostring(plName)]["archive"]["years"];
	local SortedYears = {};
	local numColon = string.find(ListYears,";");
	if (numColon ~= nil) then
		-- Extract the existing years when there are more than one year in the archives
		ListYears = { strsplit(";",ListYears) };
		numYears = table.getn(ListYears);
		table.sort(ListYears);
		isManyYears = true;
	end
	
	if (not level) then
		return;
	end
	local info = self.info;
	wipe(info);
	
	if (level == 1) then
		-- Create the title of the menu
		info.isTitle = 1;
		info.text = "Archives";
		info.notCheckable = 1;
		UIDropDownMenu_AddButton(info,level);
		
		info.keepShownOnClick = 1;
		info.disabled = nil;
		info.isTitle = nil;
		info.notCheckable = nil;
		info.checked = nil;
		
		if (isManyYears) then
			-- List years when there are more than one in archives
			for i=1,numYears do
				info.text = ListYears[i];
				info.hasArrow = 1;
				info.value = "submenu"..ListYears[i];
				info.func = function(self) 
					_G[self:GetName().."Check"]:Hide();
					ShowArchives(ListYears[i],nil)
				end;
				UIDropDownMenu_AddButton(info,level);
				_G["DropDownList1Button"..(i+1).."UnCheck"]:Hide();
				numMenuItems = numMenuItems + 1;
			end
		else
			-- List the current year
			info.text = ListYears;
			info.func = function(self)
				_G[self:GetName().."Check"]:Hide();
				ShowArchives(ListYears[i],nil)
			end;
			info.hasArrow = 1;
			info.value = "submenu"..ListYears;
			UIDropDownMenu_AddButton(info,level);
			DropDownList1Button2UnCheck:Hide();
			numMenuItems = 3;
		end
		
		-- Close Menu Item
		info.hasArrow = nil;
		info.value = nil;
		info.notCheckable = nil;
		info.text = CLOSE;
		info.func = self.HideMenu;
		UIDropDownMenu_AddButton(info,level);
		_G["DropDownList1Button"..numMenuItems.."UnCheck"]:Hide();
	elseif (level == 2) then
		if (isManyYears) then
			-- List the months that exist in the archives within each of the multiple years
			local yearCtr = 1;
			for i=1,numYears do
				if (UIDROPDOWNMENU_MENU_VALUE == "submenu"..ListYears[i]) then
					for j=1,12 do
						if (GTr_SavedVars[tostring(plName)]["archive"][tostring(ListYears[i])][tostring(months[j])] ~= nil) then
							info.text = months[j];
							info.keepShownOnClick = 1;
							info.func = function(self)
								_G[self:GetName().."Check"]:Hide();
								ShowArchives(ListYears[i],months[j])
							end;
							UIDropDownMenu_AddButton(info,level);
							_G["DropDownList2Button"..yearCtr.."UnCheck"]:Hide();
							yearCtr = yearCtr + 1;
						end
					end
				end
			end
		else
			-- List the existing months for the current year
			if (UIDROPDOWNMENU_MENU_VALUE == "submenu"..ListYears) then
				for j=1,12 do
					local uMonth = string.gsub(" "..months[j], "%W%l", string.upper):sub(2);
					if (GTr_SavedVars[tostring(plName)]["archive"][tostring(ListYears)][tostring(months[j])] ~= nil) then
						info.text = uMonth;
						info.keepShownOnClick = 1;
						info.func = function(self)
							_G[self:GetName().."Check"]:Hide();
							ShowArchives(ListYears[i],months[j])
						end;
						UIDropDownMenu_AddButton(info,level);
						_G["DropDownList2Button1UnCheck"]:Hide();
					end
				end
			end
		end
	end
end;

local function InitializeSavedVars(init,data,aux,isReset)

	if (data == "quest" or data == "vendor" or data == "spent" or data == "repair") then
		if (init) then
			--SendChatMessage(string.upper(tostring(data)).."_INIT_VAR","SAY");
			GTr_SavedVars[tostring(plName)][tostring(data)] = {};
			GTr_SavedVars[tostring(plName)][tostring(data)][tostring(curDay)] = 0;
			GTr_SavedVars[tostring(plName)][tostring(data)]["week"] = 0;
			GTr_SavedVars[tostring(plName)][tostring(data)][tostring(curMonth)] = 0;
			GTr_SavedVars[tostring(plName)][tostring(data)][tostring(curYear)] = 0;
			if (isReset) then
				GTr_SavedVars[tostring(plName)][tostring(data)]["all-time"] = 0;
			end
		else
			GTr_SavedVars[tostring(plName)][tostring(data)][tostring(aux)] = 0;
		end
		--SendChatMessage("CURDAY IS: "..string.upper(tostring(curDay)),"SAY");
		--SendChatMessage("CURDAY IS: "..string.upper(tostring(curMonth)),"SAY");
		
	else
		if (init == true) then
			--SendChatMessage(string.upper(tostring(data)).."_INIT_VAR","SAY");
			GTr_SavedVars[tostring(plName)]["all-time"] = 0;
			GTr_SavedVars[tostring(plName)]["instance"][tostring(data)] = {};
			if (isReset) then
				GTr_SavedVars[tostring(plName)]["instance"]["all-time"] = {};
				GTr_SavedVars[tostring(plName)]["instance"]["all-time"]["total"] = 0;
				GTr_SavedVars[tostring(plName)]["instance"]["all-time"]["solo"] = 0;
				GTr_SavedVars[tostring(plName)]["instance"]["all-time"]["group"] = 0;
				GTr_SavedVars[tostring(plName)]["instance"]["all-time"]["raid"] = 0;
			end
			GTr_SavedVars[tostring(plName)]["world"][tostring(data)] = {};
			if (isReset) then
				GTr_SavedVars[tostring(plName)]["world"]["all-time"] = {};
				GTr_SavedVars[tostring(plName)]["world"]["all-time"]["total"] = 0;
				GTr_SavedVars[tostring(plName)]["world"]["all-time"]["solo"] = 0;
				GTr_SavedVars[tostring(plName)]["world"]["all-time"]["group"] = 0;
				GTr_SavedVars[tostring(plName)]["world"]["all-time"]["raid"] = 0;
			end
		else
			--SendChatMessage(string.upper(tostring(data)).."_NOT_INIT_VAR","SAY");
		end
		--Initialize Instance Saved Variables
		GTr_SavedVars[tostring(plName)]["instance"][tostring(data)]["total"] = 0;
		GTr_SavedVars[tostring(plName)]["instance"][tostring(data)]["solo"] = 0;
		GTr_SavedVars[tostring(plName)]["instance"][tostring(data)]["group"] = 0;
		GTr_SavedVars[tostring(plName)]["instance"][tostring(data)]["raid"] = 0;
		
		--Initialize World Saved Variables
		GTr_SavedVars[tostring(plName)]["world"][tostring(data)]["total"] = 0;
		GTr_SavedVars[tostring(plName)]["world"][tostring(data)]["solo"] = 0;
		GTr_SavedVars[tostring(plName)]["world"][tostring(data)]["group"] = 0;
		GTr_SavedVars[tostring(plName)]["world"][tostring(data)]["raid"] = 0;
	end
end;

--[[function GoldOptionDropDown_OnLoad()
	info = {};
	info.text = "Current";
	info.value = nil;
	info.func = GoldOptionDropDownClicked;
	
	UIDropDownMenu_AddButton(info);
end

function GoldOptionDropDown_OnClick()
	--ToggleDropDownMenu(1, nil, GoldOptionDropDown, GoldOptionDropMenuButton, 0, 0);
end

function GoldOptionDropDown()
	local dateCat = {
		"day",
		"week",
		"month",
		"year"
	}
	for i=1,4 do
		local info = UIDropDownMenu_CreateInfo();
		info.text = dateCat[i];
		info.value = i;
		info.func = GoldOptionDropDownSelect;
		UIDropDownMenu_AddButton(info);
	end
end


function GoldOptionDropDownSelect(self,arg1,arg2,checked)
	
end]]

local function FormatAllTimeValues(world,instance,quest,vendor,spent,repair)
	local income = world + instance + quest + vendor;
	local expense = spent + repair;
	
	if (world == 0) then
		world = "0"
	else
		if (world < 100) then
			world = ("%dc"):format(world % 100);
		elseif (world < 10000) then
			world = ("%ds %dc"):format((world / 100) % 100, world % 100)
		else
			world = ("%dg %ds %dc"):format(world / 100 / 100, (world / 100) % 100, world % 100)
		end
	end
	
	if (instance == 0) then
		instance = "0"
	else
		if (instance < 100) then
			instance = ("%dc"):format(instance % 100);
		elseif (instance < 10000) then
			instance = ("%ds %dc"):format((instance / 100) % 100, instance % 100)
		else
			instance = ("%dg %ds %dc"):format(instance / 100 / 100, (instance / 100) % 100, instance % 100)
		end
	end
	
	if (quest == 0) then
		quest = "0"
	else
		if (quest < 100) then
			quest = ("%dc"):format(quest % 100);
		elseif (quest < 10000) then
			quest = ("%ds %dc"):format((quest / 100) % 100, quest % 100)
		else
			quest = ("%dg %ds %dc"):format(quest / 100 / 100, (quest / 100) % 100, quest % 100)
		end
	end
	
	if (vendor == 0) then
		vendor = "0"
	else
		if (vendor < 100) then
			vendor = ("%dc"):format(vendor % 100);
		elseif (vendor < 10000) then
			vendor = ("%ds %dc"):format((vendor / 100) % 100, vendor % 100)
		else
			vendor = ("%dg %ds %dc"):format(vendor / 100 / 100, (vendor / 100) % 100, vendor % 100)
		end
	end
	
	if (spent == 0) then
		spent = "0"
	else
		if (spent < 100) then
			spent = ("%dc"):format(spent % 100);
		elseif (spent < 10000) then
			spent = ("%ds %dc"):format((spent / 100) % 100, spent % 100)
		else
			spent = ("%dg %ds %dc"):format(spent / 100 / 100, (spent / 100) % 100, spent % 100)
		end
	end
	
	if (repair == 0) then
		repair = "0"
	else
		if (repair < 100) then
			repair = ("%dc"):format(repair % 100);
		elseif (repair < 10000) then
			repair = ("%ds %dc"):format((repair / 100) % 100, repair % 100)
		else
			repair = ("%dg %ds %dc"):format(repair / 100 / 100, (repair / 100) % 100, repair % 100)
		end
	end
	
	if (income == 0) then
		income = "0"
	else
		if (income < 100) then
			income = ("%dc"):format(income % 100);
		elseif (income < 10000) then
			income = ("%ds %dc"):format((income / 100) % 100, income % 100)
		else
			income = ("%dg %ds %dc"):format(income / 100 / 100, (income / 100) % 100, income % 100)
		end
	end
	
	if (expense == 0) then
		expense = "0"
	else
		if (expense < 100) then
			expense = ("%dc"):format(expense % 100);
		elseif (expense < 10000) then
			expense = ("%ds %dc"):format((expense / 100) % 100, expense % 100)
		else
			expense = ("%dg %ds %dc"):format(expense / 100 / 100, (expense / 100) % 100, expense % 100)
		end
	end
	
	GT_Globals.AT_W_Frame:SetText(world);
	GT_Globals.AT_I_Frame:SetText(instance);
	GT_Globals.AT_Q_Frame:SetText(quest);
	GT_Globals.AT_V_Frame:SetText(vendor);
	GT_Globals.AT_S_Frame:SetText(spent);
	GT_Globals.AT_R_Frame:SetText(repair);
	
	GT_Globals.AT_In_Frame:SetText(income);
	GT_Globals.AT_Ex_Frame:SetText(expense);
	
	--[[AllTimeWorldFrameText = GT_Globals.AT_W_Frame;
	AllTimeInstanceFrameText = AT_I_Frame;
	AllTimeQuestFrameText = AT_Q_Frame;
	AllTimeVendorFrameText = AT_V_Frame;
	AllTimeSpentFrameText = AT_S_Frame;
	AllTimeRepairFrameText = AT_R_Frame;

	AllTimeIncomeTotalFrameText = AT_In_Frame;
	AllTimeExpenseTotalFrameText = AT_Ex_Frame;]]
end

local function FormatValues(dayVal,weekVal,monthVal,yearVal,totalVal,method)
	if (dayVal == 0) then
		dayVal = "0";
	else
		if (dayVal < 100) then
			dayVal = ("%dc"):format(dayVal % 100);
		elseif (dayVal < 10000) then
			dayVal = ("%ds %dc"):format((dayVal / 100) % 100, dayVal % 100)
		else
			dayVal = ("%dg %ds %dc"):format(dayVal / 100 / 100, (dayVal / 100) % 100, dayVal % 100)
		end
	end
	
	if (weekVal == 0) then
		weekVal = "0";
	else
		if (weekVal < 100) then
			weekVal = ("%dc"):format(weekVal % 100);
		elseif (weekVal < 10000) then
			weekVal = ("%ds %dc"):format((weekVal / 100) % 100, weekVal % 100)
		else
			weekVal = ("%dg %ds %dc"):format(weekVal / 100 / 100, (weekVal / 100) % 100, weekVal % 100)
		end
	end
	
	if (monthVal == 0) then
		monthVal = "0";
	else
		if (monthVal < 100) then
			monthVal = ("%dc"):format(monthVal % 100);
		elseif (monthVal < 10000) then
			monthVal = ("%ds %dc"):format((monthVal / 100) % 100, monthVal % 100)
		else
			monthVal = ("%dg %ds %dc"):format(monthVal / 100 / 100, (monthVal / 100) % 100, monthVal % 100)
		end
	end
	
	if (yearVal == 0) then
		yearVal = "0";
	else
		if (yearVal < 100) then
			yearVal = ("%dc"):format(yearVal % 100);
		elseif (yearVal < 10000) then
			yearVal = ("%ds %dc"):format((yearVal / 100) % 100, yearVal % 100)
		else
			yearVal = ("%dg %ds %dc"):format(yearVal / 100 / 100, (yearVal / 100) % 100, yearVal % 100)
		end
	end
	
	--[[if (totalVal ~= '') then
		local spentVal = tonumber(GTr_SavedVars[tostring(plName)]["spent"]["all-time"])
		local repairVal = tonumber(GTr_SavedVars[tostring(plName)]["repair"]["all-time"]);
		local income,expense = 0,0;
		
		SendChatMessage("Day: '"..tostring(dayVal).."'","SAY");
		SendChatMessage("Week: '"..tostring(weekVal).."'","SAY");
		SendChatMessage("Month: '"..tostring(monthVal).."'","SAY");
		SendChatMessage("Year: '"..tostring(yearVal).."'","SAY");
		income = tonumber(dayVal) + tonumber(weekVal) + tonumber(monthVal) + tonumber(yearVal);
		expense = tonumber(spentVal) + tonumber(repairVal);
		
		if (totalVal < 100) then
			totalVal = ("%dc"):format(totalVal % 100);
		elseif (totalVal < 10000) then
			totalVal = ("%ds %dc"):format((totalVal / 100) % 100, totalVal % 100)
		else
			totalVal = ("%dg %ds %dc"):format(totalVal / 100 / 100, (totalVal / 100) % 100, totalVal % 100)
		end
		
		if (spentVal < 100) then
			spentVal = ("%dc"):format(spentVal % 100);
		elseif (spentVal < 10000) then
			spentVal = ("%ds %dc"):format((spentVal / 100) % 100, spentVal % 100)
		else
			spentVal = ("%dg %ds %dc"):format(spentVal / 100 / 100, (spentVal / 100) % 100, spentVal % 100)
		end
		
		if (repairVal < 100) then
			repairVal = ("%dc"):format(repairVal % 100);
		elseif (repairVal < 10000) then
			repairVal = ("%ds %dc"):format((repairVal / 100) % 100, repairVal % 100)
		else
			repairVal = ("%dg %ds %dc"):format(repairVal / 100 / 100, (repairVal / 100) % 100, repairVal % 100)
		end
		
		if (income < 100) then
			income = ("%dc"):format(income % 100);
		elseif (income < 10000) then
			income = ("%ds %dc"):format((income / 100) % 100, income % 100)
		else
			income = ("%dg %ds %dc"):format(income / 100 / 100, (income / 100) % 100, income % 100)
		end
		
		if (expense < 100) then
			expense = ("%dc"):format(expense % 100);
		elseif (expense < 10000) then
			expense = ("%ds %dc"):format((expense / 100) % 100, expense % 100)
		else
			expense = ("%dg %ds %dc"):format(expense / 100 / 100, (expense / 100) % 100, expense % 100)
		end
		AllTimeWorldFrameText:SetText(dayVal);
		AllTimeInstanceFrameText:SetText(weekVal);
		AllTimeQuestFrameText:SetText(monthVal);
		AllTimeVendorFrameText:SetText(yearVal);
		AllTimeSpentFrameText:SetText(spentVal);
		AllTimeRepairFrameText:SetText(repairVal);
		
		AllTimeIncomeTotalFrameText:SetText(income);
		AllTimeExpenseTotalFrameText:SetText(totalVal);
	end]]
	
	if (method == "world") then
		GT_Globals.W_D_Frame:SetText(dayVal);
		GT_Globals.W_W_Frame:SetText(weekVal);
		GT_Globals.W_M_Frame:SetText(monthVal);
		GT_Globals.W_Y_Frame:SetText(yearVal);
	elseif (method == "instance") then
		GT_Globals.I_D_Frame:SetText(dayVal);
		GT_Globals.I_W_Frame:SetText(weekVal);
		GT_Globals.I_M_Frame:SetText(monthVal);
		GT_Globals.I_Y_Frame:SetText(yearVal);
	elseif (method == "quest") then
		GT_Globals.Q_D_Frame:SetText(dayVal);
		GT_Globals.Q_W_Frame:SetText(weekVal);
		GT_Globals.Q_M_Frame:SetText(monthVal);
		GT_Globals.Q_Y_Frame:SetText(yearVal);
	elseif (method == "vendor") then
		GT_Globals.V_D_Frame:SetText(dayVal);
		GT_Globals.V_W_Frame:SetText(weekVal);
		GT_Globals.V_M_Frame:SetText(monthVal);
		GT_Globals.V_Y_Frame:SetText(yearVal);
	elseif (method == "spent") then
		GT_Globals.S_D_Frame:SetText(dayVal);
		GT_Globals.S_W_Frame:SetText(weekVal);
		GT_Globals.S_M_Frame:SetText(monthVal);
		GT_Globals.S_Y_Frame:SetText(yearVal);
	elseif (method == "repair") then
		GT_Globals.R_D_Frame:SetText(dayVal);
		GT_Globals.R_W_Frame:SetText(weekVal);
		GT_Globals.R_M_Frame:SetText(monthVal);
		GT_Globals.R_Y_Frame:SetText(yearVal);
	end
end

local function InitAddon()
	print("Month: '"..tostring(month).."'");
	curDay = weekdays[weekday];
	curMonth = months[month];
	curYear = year;

	--curMoney = GetMoney();
	--SendChatMessage(tostring(curMoney),"SAY");
	
	-- Initialize Frame Variables
	--[[WorldDayFrameText = GT_Globals.W_D_Frame;
	WorldWeekFrameText = GT_Globals.W_W_Frame;
	WorldMonthFrameText = GT_Globals.W_M_Frame;
	WorldYearFrameText = GT_Globals.W_Y_Frame;

	InstanceDayFrameText = GT_Globals.I_D_Frame;
	InstanceWeekFrameText = GT_Globals.I_W_Frame;
	InstanceMonthFrameText = GT_Globals.I_M_Frame;
	InstanceYearFrameText = GT_Globals.I_Y_Frame;

	QuestDayFrameText = GT_Globals.Q_D_Frame;
	QuestWeekFrameText = GT_Globals.Q_Q_Frame;
	QuestMonthFrameText = GT_Globals.Q_M_Frame;
	QuestYearFrameText = GT_Globals.Q_Y_Frame;

	VendorDayFrameText = GT_Globals.V_D_Frame;
	VendorWeekFrameText = GT_Globals.V_W_Frame;
	VendorMonthFrameText = GT_Globals.V_M_Frame;
	VendorYearFrameText = GT_Globals.V_Y_Frame;

	SpentDayFrameText = GT_Globals.S_D_Frame;
	SpentWeekFrameText = GT_Globals.S_W_Frame;
	SpentMonthFrameText = GT_Globals.S_M_Frame;
	SpentYearFrameText = GT_Globals.S_Y_Frame;

	RepairDayFrameText = GT_Globals.R_D_Frame;
	RepairWeekFrameText = GT_Globals.R_W_Frame;
	RepairMonthFrameText = GT_Globals.R_M_Frame;
	RepairYearFrameText = GT_Globals.R_Y_Frame;]]
		
	
	
	--Initialize Saved Variables
	if (GTr_SavedVars == nil) then
		--SendChatMessage("INIT","SAY");
		
		GTr_SavedVars = {};
		GTr_SavedVars[tostring(plName)] = {};
		GTr_SavedVars[tostring(plName)]["curDay"] = curDay;
		GTr_SavedVars[tostring(plName)]["curMonth"] = curMonth;
		GTr_SavedVars[tostring(plName)]["curYear"] = curYear;
		GTr_SavedVars[tostring(plName)]["instance"] = {};
		GTr_SavedVars[tostring(plName)]["world"] = {};
		GTr_SavedVars[tostring(plName)]["archive"] = {};
		GTr_SavedVars[tostring(plName)]["archive"]["years"] = tostring(curYear);
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)] = {};
		
		-- Set Year Archive Saved Variables
		GTr_SavedVars[tostring(plName)]["archive"]["years"] = tostring(curYear);
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)] = {};
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["instance"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["world"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["vendor"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["spent"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["repair"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["quest"] = 0;
		
		
		-- Set Month Archive Saved Variables
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)] = {};
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["instance"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["world"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["vendor"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["spent"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["repair"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["quest"] = 0;
		
		InitializeSavedVars(true,curYear,'',true);
		InitializeSavedVars(true,curMonth,'',true);
		InitializeSavedVars(true,"week",'',true);
		InitializeSavedVars(true,curDay,'',true);
		InitializeSavedVars(true,"quest",'',true);
		InitializeSavedVars(true,"vendor",'',true);
		InitializeSavedVars(true,"spent",'',true);
		InitializeSavedVars(true,"repair",'',true);
	end
	print("Saved Day: '"..GTr_SavedVars[tostring(plName)]["curDay"].."'");
	print("Current Day: '"..curDay.."'");
	print("---------------------------");
	--Check for obsolete Day Saved Variables
	if (GTr_SavedVars[tostring(plName)]["curDay"] ~= curDay) then
		SendChatMessage("DAY","SAY");
		local oldDay = GTr_SavedVars[tostring(plName)]["curDay"];
		GTr_SavedVars[tostring(plName)]["curDay"] = curDay;
		
		-- Reset day variables
		GTr_SavedVars[tostring(plName)]["instance"][tostring(oldDay)] = nil;
		GTr_SavedVars[tostring(plName)]["world"][tostring(oldDay)] = nil;
		GTr_SavedVars[tostring(plName)]["quest"][tostring(oldDay)] = nil;
		GTr_SavedVars[tostring(plName)]["vendor"][tostring(oldDay)] = nil;
		GTr_SavedVars[tostring(plName)]["spent"][tostring(oldDay)] = nil;
		GTr_SavedVars[tostring(plName)]["repair"][tostring(oldDay)] = nil;
		
		InitializeSavedVars(true,curDay,'',false);
		InitializeSavedVars(false,'quest',curDay,false);
		InitializeSavedVars(false,'vendor',curDay,false);
		InitializeSavedVars(false,'spent',curDay,false);
		InitializeSavedVars(false,'repair',curDay,false);
	else
		--SendChatMessage(string.upper("NO_DAY_CHANGE","SAY"));
	end
	
	--Check for obsolete Month Saved Variables
	SendChatMessage("Saved Month: '"..tostring(GTr_SavedVars[tostring(plName)]["curMonth"]).."'","SAY");
	SendChatMessage("Current Month: '"..tostring(curMonth).."'","SAY");
	if (GTr_SavedVars[tostring(plName)]["curMonth"] ~= curMonth) then
		SendChatMessage("MONTH","SAY");
		local oldMonth = GTr_SavedVars[tostring(plName)]["curMonth"];
		GTr_SavedVars[tostring(plName)]["curMonth"] = curMonth;
		
		-- reset month
		GTr_SavedVars[tostring(plName)]["instance"][tostring(oldMonth)] = nil;
		GTr_SavedVars[tostring(plName)]["world"][tostring(oldMonth)] = nil;
		GTr_SavedVars[tostring(plName)]["quest"][tostring(oldMonth)] = nil;
		GTr_SavedVars[tostring(plName)]["vendor"][tostring(oldMonth)] = nil;
		GTr_SavedVars[tostring(plName)]["spent"][tostring(oldMonth)] = nil;
		GTr_SavedVars[tostring(plName)]["repair"][tostring(oldMonth)] = nil;
		
		-- Add New Month to Archive Saved Variables
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)] = {};
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["instance"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["world"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["vendor"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["spent"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["repair"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["quest"] = 0;
		
		InitializeSavedVars(true,curMonth,'',false);
		InitializeSavedVars(false,'quest',curMonth,false);
		InitializeSavedVars(false,'vendor',curMonth,false);
		InitializeSavedVars(false,'spent',curMonth,false);
		InitializeSavedVars(false,'repair',curMonth,false);
	else
		--SendChatMessage(string.upper("NO_MONTH_CHANGE","SAY"));
	end
	
	--Check for obsolete Year Saved Variables
	if (GTr_SavedVars[tostring(plName)]["curYear"] ~= curYear) then
		SendChatMessage("YEAR","SAY");
		local oldYear = GTr_SavedVars[tostring(plName)]["curYear"];
		GTr_SavedVars[tostring(plName)]["curYear"] = curYear;
		
		-- reset year variables
		GTr_SavedVars[tostring(plName)]["instance"][tostring(oldYear)] = nil;
		GTr_SavedVars[tostring(plName)]["world"][tostring(oldYear)] = nil;
		GTr_SavedVars[tostring(plName)]["quest"][tostring(oldYear)] = nil;
		GTr_SavedVars[tostring(plName)]["vendor"][tostring(oldYear)] = nil;
		GTr_SavedVars[tostring(plName)]["spent"][tostring(oldYear)] = nil;
		GTr_SavedVars[tostring(plName)]["repair"][tostring(oldYear)] = nil;
		
		-- Add new year to archive saved variables
		GTr_SavedVars[tostring(plName)]["archive"]["years"] = GTr_SavedVars[tostring(plName)]["archive"]["years"]..";"..tostring(curYear);
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)] = {};
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["instance"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["world"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["vendor"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["spent"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["repair"] = 0;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["quest"] = 0;
		
		InitializeSavedVars(true,curYear,'',false);
		InitializeSavedVars(false,'quest',curYear,false);
		InitializeSavedVars(false,'vendor',curYear,false);
		InitializeSavedVars(false,'spent',curYear,false);
		InitializeSavedVars(false,'repair',curYear,false);
	else
		--SendChatMessage(string.upper("NO_YEAR_CHANGE","SAY"));
	end
	
	if (curDay == "Sunday" and isWeekA and not weekChange) then
		--SendChatMessage("WEEK-B","SAY");
		isWeekA = false;
		isWeekB = true;
		weekChange = true;
		InitializeSavedVars(false,"week",'',false);
		InitializeSavedVars(false,"quest",'week',false);
		InitializeSavedVars(false,"vendor",'week',false);
		InitializeSavedVars(false,"spent",'week',false);
		InitializeSavedVars(false,"repair",'week',false);
	elseif (curDay == "Sunday" and isWeekB and not weekChange) then
		--SendChatMessage("WEEK-A","SAY");
		isWeekA = true;
		isWeekB = false;
		weekChange = true;
		InitializeSavedVars(false,"week",false);
		InitializeSavedVars(false,"quest",'week',false);
		InitializeSavedVars(false,"vendor",'week',false);
		InitializeSavedVars(false,"spent",'week',false);
		InitializeSavedVars(false,"repair",'week',false);
	else
		--SendChatMessage(string.upper("NO_WEEK_CHANGE","SAY"));
	end
	
	if (curDay == "Monday" and weekChange) then
		--SendChatMessage("WEEK_CHANGE","SAY");
		weekChange = false;
	end
	
	-- INITIALIZE FRAMES --
	--SendChatMessage("OH HAI!","SAY");
	GT_Globals.initGoldDialog(GoldDialog);
	GT_Globals.initArchiveDialog(ArchiveDialog);
	
	FormatValues(GTr_SavedVars[tostring(plName)]["world"][tostring(curDay)]["total"],GTr_SavedVars[tostring(plName)]["world"]['week']["total"],GTr_SavedVars[tostring(plName)]["world"][tostring(curMonth)]["total"],GTr_SavedVars[tostring(plName)]["world"][tostring(curYear)]["total"],'',"world");
	FormatValues(GTr_SavedVars[tostring(plName)]["instance"][tostring(curDay)]["total"],GTr_SavedVars[tostring(plName)]["instance"]['week']["total"],GTr_SavedVars[tostring(plName)]["instance"][tostring(curMonth)]["total"],GTr_SavedVars[tostring(plName)]["instance"][tostring(curYear)]["total"],'',"instance");
	FormatValues(GTr_SavedVars[tostring(plName)]["quest"][tostring(curDay)],GTr_SavedVars[tostring(plName)]["quest"]['week'],GTr_SavedVars[tostring(plName)]["quest"][tostring(curMonth)],GTr_SavedVars[tostring(plName)]["quest"][tostring(curYear)],'',"quest");
	FormatValues(GTr_SavedVars[tostring(plName)]["vendor"][tostring(curDay)],GTr_SavedVars[tostring(plName)]["vendor"]['week'],GTr_SavedVars[tostring(plName)]["vendor"][tostring(curMonth)],GTr_SavedVars[tostring(plName)]["vendor"][tostring(curYear)],'',"vendor");
	FormatValues(GTr_SavedVars[tostring(plName)]["spent"][tostring(curDay)],GTr_SavedVars[tostring(plName)]["spent"]['week'],GTr_SavedVars[tostring(plName)]["spent"][tostring(curMonth)],GTr_SavedVars[tostring(plName)]["spent"][tostring(curYear)],'',"spent");
	FormatValues(GTr_SavedVars[tostring(plName)]["repair"][tostring(curDay)],GTr_SavedVars[tostring(plName)]["repair"]['week'],GTr_SavedVars[tostring(plName)]["repair"][tostring(curMonth)],GTr_SavedVars[tostring(plName)]["repair"][tostring(curYear)],'',"repair");
	FormatAllTimeValues(GTr_SavedVars[tostring(plName)]["world"]["all-time"]["total"],GTr_SavedVars[tostring(plName)]["instance"]["all-time"]["total"],GTr_SavedVars[tostring(plName)]["quest"]["all-time"],GTr_SavedVars[tostring(plName)]["vendor"]["all-time"],GTr_SavedVars[tostring(plName)]["spent"]["all-time"],GTr_SavedVars[tostring(plName)]["repair"]["all-time"]);
end;

local function GetMoneyString()
	local copper = GetMoney();
	return ("%d%d%d"):format(copper % 100, (copper / 100) % 100, copper / 100 / 100);
end;

local function CurrentMoney()
	print("Getting Current Money");
	--[[local copper = GetMoneyString();
	local findGold,findSilver,findCopper = 0,0,0;
	
	curCopper,curSilver,curGold = string.split(copper," ");
	
	if (curGold ~= nil) then
		findGold = string.find("g",curGold);
		curGold = tonumber(string.sub(curGold,1,(findGold-1)));
	end
	
	if (curSilver ~= nil) then
		findSilver = string.find("g",curSilver);
		curSilver = tonumber(string.sub(curSilver,1,(findSilver-1)));
	end
	
	if (curCopper ~= nil) then
		findCopper = string.find("g",curCopper);
		curCopper = tonumber(string.sub(curCopper,1,(findCopper-1)));
	end]]
	curMoney = GetMoney();
end;

local function GetMoneyDifference()
	local moneyDiff = 0;
	
	NewMoney = GetMoney();
	moneyDiff = NewMoney - curMoney;
	curMoney = GetMoney();
	return moneyDiff;
end

local function MerchantMoney()
	local moneyDiff;
	moneyDiff = GetMoneyDifference();
	
	if (isPurchase) then
		moneyDiff = moneyDiff * -1;
		SpendTotal = SpendTotal + moneyDiff;
		isPurchase = false;
	elseif (isRepair) then
		moneyDiff = moneyDiff * -1;
		RepairTotal = RepairTotal + moneyDiff;
		isRepair = false;
	else
		if (NewMoney > curMoney) then
			GainTotal = GainTotal - moneyDiff;
		else
			GainTotal = GainTotal + moneyDiff;
		end
	end
	print("Spent: '"..tostring(SpendTotal).."'");
	print("Gained: '"..tostring(GainTotal).."'");
	print("Repaired: '"..tostring(RepairTotal).."'");
end

local function UpdateMoney(isCloseMerchant)
	local moneyDiff = 0;
	local questMoney = 0;
	if (isQuest) then
		questMoney = GetRewardMoney();
	else
		moneyDiff = GetMoneyDifference();
	end
	--print("Money Difference 2: "..tostring(moneyDiff));
	--local totalMoney = ("%d%d%d"):format(moneyDiff / 100 / 100, (moneyDiff / 100) % 100, moneyDiff % 100);
	if (isQuest) then
		SendChatMessage(string.upper("QUEST_MONEY","SAY"));
		GTr_SavedVars[tostring(plName)]["quest"][tostring(curDay)] = GTr_SavedVars[tostring(plName)]["quest"][tostring(curDay)] + questMoney;
		GTr_SavedVars[tostring(plName)]["quest"][tostring(curMonth)] = GTr_SavedVars[tostring(plName)]["quest"][tostring(curMonth)] + questMoney;
		GTr_SavedVars[tostring(plName)]["quest"]["week"] = GTr_SavedVars[tostring(plName)]["quest"]["week"] + questMoney;
		GTr_SavedVars[tostring(plName)]["quest"][tostring(curYear)] = GTr_SavedVars[tostring(plName)]["quest"][tostring(curYear)] + questMoney;
		GTr_SavedVars[tostring(plName)]["quest"]["all-time"] = GTr_SavedVars[tostring(plName)]["quest"]["all-time"] + questMoney;
		GTr_SavedVars[tostring(plName)]["all-time"] = GTr_SavedVars[tostring(plName)]["all-time"] + questMoney;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["quest"] = GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["quest"] + questMoney;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["quest"] = GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["quest"] + questMoney;
	--elseif (isVendor and isPurchase == false) then
	elseif (isCloseMerchant) then
		print("Not purchase");
		--SendChatMessage(string.upper("VENDOR_MONEY","SAY"));
		if (GainTotal > 0) then
			GTr_SavedVars[tostring(plName)]["vendor"][tostring(curDay)] = GTr_SavedVars[tostring(plName)]["vendor"][tostring(curDay)] + GainTotal;
			GTr_SavedVars[tostring(plName)]["vendor"][tostring(curMonth)] = GTr_SavedVars[tostring(plName)]["vendor"][tostring(curMonth)] + GainTotal;
			GTr_SavedVars[tostring(plName)]["vendor"]["week"] = GTr_SavedVars[tostring(plName)]["vendor"]["week"] + GainTotal;
			GTr_SavedVars[tostring(plName)]["vendor"][tostring(curYear)] = GTr_SavedVars[tostring(plName)]["vendor"][tostring(curYear)] + GainTotal;
			GTr_SavedVars[tostring(plName)]["vendor"]["all-time"] = GTr_SavedVars[tostring(plName)]["vendor"]["all-time"] + GainTotal;
			GTr_SavedVars[tostring(plName)]["all-time"] = GTr_SavedVars[tostring(plName)]["all-time"] + GainTotal;
			GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["vendor"] = GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["vendor"] + GainTotal;
			GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["vendor"] = GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["vendor"] + GainTotal;
		end
		if (SpendTotal > 0) then
			GTr_SavedVars[tostring(plName)]["spent"][tostring(curDay)] = GTr_SavedVars[tostring(plName)]["spent"][tostring(curDay)] + SpendTotal;
			GTr_SavedVars[tostring(plName)]["spent"][tostring(curMonth)] = GTr_SavedVars[tostring(plName)]["spent"][tostring(curMonth)] + SpendTotal;
			GTr_SavedVars[tostring(plName)]["spent"]["week"] = GTr_SavedVars[tostring(plName)]["spent"]["week"] + SpendTotal;
			GTr_SavedVars[tostring(plName)]["spent"][tostring(curYear)] = GTr_SavedVars[tostring(plName)]["spent"][tostring(curYear)] + SpendTotal;
			GTr_SavedVars[tostring(plName)]["spent"]["all-time"] = GTr_SavedVars[tostring(plName)]["spent"]["all-time"] + SpendTotal;
			GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["spent"] = GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["spent"] + SpendTotal;
			GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["spent"] = GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["spent"] + SpendTotal;
		end
		if (RepairTotal > 0) then
			GTr_SavedVars[tostring(plName)]["repair"][tostring(curDay)] = GTr_SavedVars[tostring(plName)]["repair"][tostring(curDay)] + RepairTotal;
			GTr_SavedVars[tostring(plName)]["repair"][tostring(curMonth)] = GTr_SavedVars[tostring(plName)]["repair"][tostring(curMonth)] + RepairTotal;
			GTr_SavedVars[tostring(plName)]["repair"]["week"] = GTr_SavedVars[tostring(plName)]["repair"]["week"] + RepairTotal;
			GTr_SavedVars[tostring(plName)]["repair"][tostring(curYear)] = GTr_SavedVars[tostring(plName)]["repair"][tostring(curYear)] + RepairTotal;
			GTr_SavedVars[tostring(plName)]["repair"]["all-time"] = GTr_SavedVars[tostring(plName)]["repair"]["all-time"] + RepairTotal;
			GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["repair"] = GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["repair"] + RepairTotal;
			GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["repair"] = GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["repair"] + RepairTotal;
		end
		GainTotal = 0;
		SpendTotal = 0;
		RepairTotal = 0;
	--[[elseif (isVendor and isPurchase) then
		print("Purchase");
		isPurchase = false;]]
	elseif (isInstance) then
		--SendChatMessage(string.upper("INSTANCE_MONEY","SAY"));
		-- Instance Day Adjust
		GTr_SavedVars[tostring(plName)]["instance"][tostring(curDay)]["total"] = GTr_SavedVars[tostring(plName)]["instance"][tostring(curDay)]["total"] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["instance"][tostring(curDay)][tostring(trackType)] = GTr_SavedVars[tostring(plName)]["instance"][tostring(curDay)][tostring(trackType)] + moneyDiff;
		-- Instance Week Adjust
		GTr_SavedVars[tostring(plName)]["instance"]["week"]["total"] = GTr_SavedVars[tostring(plName)]["instance"]["week"]["total"] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["instance"]["week"][tostring(trackType)] = GTr_SavedVars[tostring(plName)]["instance"]["week"][tostring(trackType)] + moneyDiff;
		-- Instance Month Adjust
		GTr_SavedVars[tostring(plName)]["instance"][tostring(curMonth)]["total"] = GTr_SavedVars[tostring(plName)]["instance"][tostring(curMonth)]["total"] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["instance"][tostring(curMonth)][tostring(trackType)] = GTr_SavedVars[tostring(plName)]["instance"][tostring(curMonth)][tostring(trackType)] + moneyDiff;
		-- Instance Year Adjust
		GTr_SavedVars[tostring(plName)]["instance"][tostring(curYear)]["total"] = GTr_SavedVars[tostring(plName)]["instance"][tostring(curYear)]["total"] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["instance"][tostring(curYear)][tostring(trackType)] = GTr_SavedVars[tostring(plName)]["instance"][tostring(curYear)][tostring(trackType)] + moneyDiff;
		-- Instance All-Time Adjust
		GTr_SavedVars[tostring(plName)]["instance"]["all-time"]["total"] = GTr_SavedVars[tostring(plName)]["instance"]["all-time"]["total"] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["instance"]["all-time"][tostring(trackType)] = GTr_SavedVars[tostring(plName)]["instance"]["all-time"][tostring(trackType)] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["all-time"] = GTr_SavedVars[tostring(plName)]["all-time"] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["instance"] = GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["instance"] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["instance"] = GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["instance"] + moneyDiff;
	elseif (not isInstance) then
		--SendChatMessage(string.upper("WORLD_MONEY .."..tostring(moneyDiff),"SAY"));
		-- World Day Adjust
		GTr_SavedVars[tostring(plName)]["world"][tostring(curDay)]["total"] = GTr_SavedVars[tostring(plName)]["world"][tostring(curDay)]["total"] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["world"][tostring(curDay)][tostring(trackType)] = GTr_SavedVars[tostring(plName)]["world"][tostring(curDay)][tostring(trackType)] + moneyDiff;
		-- World Week Adjust
		GTr_SavedVars[tostring(plName)]["world"]["week"]["total"] = GTr_SavedVars[tostring(plName)]["world"]["week"]["total"] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["world"]["week"][tostring(trackType)] = GTr_SavedVars[tostring(plName)]["world"]["week"][tostring(trackType)] + moneyDiff;
		-- World Month Adjust
		GTr_SavedVars[tostring(plName)]["world"][tostring(curMonth)]["total"] = GTr_SavedVars[tostring(plName)]["world"][tostring(curMonth)]["total"] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["world"][tostring(curMonth)][tostring(trackType)] = GTr_SavedVars[tostring(plName)]["world"][tostring(curMonth)][tostring(trackType)] + moneyDiff;
		-- World Year Adjust
		GTr_SavedVars[tostring(plName)]["world"][tostring(curYear)]["total"] = GTr_SavedVars[tostring(plName)]["world"][tostring(curYear)]["total"] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["world"][tostring(curYear)][tostring(trackType)] = GTr_SavedVars[tostring(plName)]["world"][tostring(curYear)][tostring(trackType)] + moneyDiff;
		-- World All-Time Adjust
		GTr_SavedVars[tostring(plName)]["world"]["all-time"]["total"] = GTr_SavedVars[tostring(plName)]["world"]["all-time"]["total"] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["world"]["all-time"][tostring(trackType)] = GTr_SavedVars[tostring(plName)]["world"]["all-time"][tostring(trackType)] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["all-time"] = GTr_SavedVars[tostring(plName)]["all-time"] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["world"] = GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)]["world"] + moneyDiff;
		GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["world"] = GTr_SavedVars[tostring(plName)]["archive"][tostring(curYear)][tostring(curMonth)]["world"] + moneyDiff;
	end

	
	FormatValues(GTr_SavedVars[tostring(plName)]["world"][tostring(curDay)]["total"],GTr_SavedVars[tostring(plName)]["world"]["week"]["total"],GTr_SavedVars[tostring(plName)]["world"][tostring(curMonth)]["total"],GTr_SavedVars[tostring(plName)]["world"][tostring(curYear)]["total"],'','world');
	FormatValues(GTr_SavedVars[tostring(plName)]["instance"][tostring(curDay)]["total"],GTr_SavedVars[tostring(plName)]["instance"]["week"]["total"],GTr_SavedVars[tostring(plName)]["instance"][tostring(curMonth)]["total"],GTr_SavedVars[tostring(plName)]["instance"][tostring(curYear)]["total"],'',"instance")
	FormatValues(GTr_SavedVars[tostring(plName)]["quest"][tostring(curDay)],GTr_SavedVars[tostring(plName)]["quest"]["week"],GTr_SavedVars[tostring(plName)]["quest"][tostring(curMonth)],GTr_SavedVars[tostring(plName)]["quest"][tostring(curYear)],'','quest');
	FormatValues(GTr_SavedVars[tostring(plName)]["vendor"][tostring(curDay)],GTr_SavedVars[tostring(plName)]["vendor"]["week"],GTr_SavedVars[tostring(plName)]["vendor"][tostring(curMonth)],GTr_SavedVars[tostring(plName)]["vendor"][tostring(curYear)],'',"vendor")
	FormatValues(GTr_SavedVars[tostring(plName)]["spent"][tostring(curDay)],GTr_SavedVars[tostring(plName)]["spent"]["week"],GTr_SavedVars[tostring(plName)]["spent"][tostring(curMonth)],GTr_SavedVars[tostring(plName)]["spent"][tostring(curYear)],'',"spent")
	FormatValues(GTr_SavedVars[tostring(plName)]["repair"][tostring(curDay)],GTr_SavedVars[tostring(plName)]["repair"]["week"],GTr_SavedVars[tostring(plName)]["repair"][tostring(curMonth)],GTr_SavedVars[tostring(plName)]["repair"][tostring(curYear)],'',"repair")
	FormatAllTimeValues(GTr_SavedVars[tostring(plName)]["world"]["all-time"]["total"],GTr_SavedVars[tostring(plName)]["instance"]["all-time"]["total"],GTr_SavedVars[tostring(plName)]["quest"]["all-time"],GTr_SavedVars[tostring(plName)]["vendor"]["all-time"],GTr_SavedVars[tostring(plName)]["spent"]["all-time"],GTr_SavedVars[tostring(plName)]["repair"]["all-time"]);
	
	curMoney = GetMoney();
end;

local function FindMoney(msg)
	--[[local isMoneyFound = nil;
	local isGoldFound = {};
	local isSilverFound = {};
	local isCopperFound = {};
	
	local goldAmount = 0;
	local silverAmount = 0;
	local copperAmount = 0;
	
	local firstSpace = nil;
	local secondSpace = nil;
	local thirdSpace = nil;
	local fourthSpace = nil;
	local fifthSpace = nil;
	local sixthSpace = nil;
	-- Received 8 gold 12 silver 20 copper
	isMoneyFound = string.find(msg, "Received");
	/script local a="Received 888888 gold 12654 silver";local b={};b[1],b[2]=strfind(a,"gold");local c=strfind(a,"silver");b[2]=b[2]+2;c=c-2;local d=strsub(a,b[2],c);print("'"..d.."'");
	/script local a="Received 8 gold";local b=strfind(a," ");local c=strfind(a,"gold");c-2;print("B: "..b.."\nC: "..c);
	if (isMoneyFound ~= nil) then
		isGoldFound[1],isGoldFound[2] = string.find(msg, "gold");
		isSilverFound[1], isSilverFound[2] = string.find(msg, "silver");
		isCopperFound = string.find(msg, "copper");
		
		if (isGoldFound ~= nil or isSilverFound ~= nil or isCopperFound ~= nil) then
			if (isGoldFound ~= nil) then
				firstSpace = string.find(msg," ")+1;
				secondSpace = string.find(msg,"gold")-2;
				goldAmount = string.sub(msg,firstSpace,secondSpace);
			end
			
			if (isSilverFound ~= nil) then
				thirdSpace = isGoldFound[2] + 2;
				fourthSpace = isSilverFound[1] - 2;
				silverAmount = string.sub(msg,thirdSpace,fourthSpace);
			end
		end
	end]]
	--[[local numLoot = GetNumLootItems();
	local lootName = '';
	local intIcon = 0;
	local slotNum = 0;
	
	local isGold = false;
	local isSilver = false;
	local isCopper = false;
	
	for i=1,numLoot,1 do
		if (GetLootSlotType(i) == "LOOT_SLOT_MONEY") then
			_,lootName = GetLootSlotInfo(i);
			break;
		end
	end;
	
	if (string.find(lootName,"Gold") ~= nil) then
		isGold = true;
	end]]
end

local function GetTrackType()
	if (GetNumGroupMembers() == 0) then
		trackType = 'solo';
	elseif (GetNumGroupMembers() > 0 and GetNumGroupMembers() < 5) then
		trackType = 'group';
	elseif (GetNumGroupMembers() > 5) then
		trackType = 'raid';
	end
	
	if (IsInInstance()) then
		isInstance = true;
		isTracking = true;
	else
		isInstance = false;
		isTracking = false;
	end
end

--Events:HookScript("OnEvent",function(self,event,...)
Events:HookScript("OnEvent",function(self,event,...)
	if (event == "ADDON_LOADED") then
		if (select(1,...) == "GoldTracker") then
			InitializeVars();
			InitAddon();
		end
	elseif (event == "PLAYER_ENTERING_WORLD") then
		curMoney = GetMoney();
		--print("Day is: "..curDay);
		--print("Month is: "..curMonth);
		GetTrackType();
	elseif (event == "LOOT_OPENED") then
		--CurrentMoney();
		--Events:RegisterEvent("LOOT_CLOSED");
		--Events:RegisterEvent("CHAT_MSG_MONEY");
	elseif (event == "CHAT_MSG_MONEY") then
		UpdateMoney(false);
		--Events:UnregisterEvent("LOOT_CLOSED");
		--Events:UnregisterEvent("CHAT_MSG_MONEY");
	elseif (event == "QUEST_COMPLETE") then
		--print("QUEST COMPLETE!");
		local events = GoldTrackerEvents;
		isQuest = true;
		--GT_Globals.W_D_LabelText:SetText(tostring(isQuest));
		Events:RegisterEvent("CHAT_MSG_SYSTEM");
		Events:RegisterEvent("QUEST_FINISHED");
	elseif (event == "QUEST_FINISHED") then
		--print("QUEST FINISHED");
		isQuest = false;
		--WorldDayLabelText:SetText(tostring(isQuest));
		Events:UnregisterEvent(tostring(event));
	elseif (event == "MERCHANT_SHOW") then
		print("Merchant Open");
		local events = GoldTrackerEvents;
		isVendor = true;
		Events:RegisterEvent("ITEM_PUSH");
		Events:RegisterEvent("PLAYER_MONEY");
		Events:RegisterEvent("MERCHANT_CLOSED");
		Events:RegisterEvent("UPDATE_INVENTORY_DURABILITY");
	elseif (event == "UPDATE_INVENTORY_DURABILITY") then
		isRepair = true;
	elseif (event == "PLAYER_MONEY") then
		print("Money Change");
		--print(tostring(isPurchase));
		if (isVendor or isPurchase or isRepair) then
			MerchantMoney();
		end
		--print("Old: "..tostring(curMoney));
		--print("New: "..tostring(GetMoney()));
	elseif (event == "MERCHANT_CLOSED") then
		if (isVendor) then
			isVendor = false;
			UpdateMoney(true);
			Events:UnregisterEvent(tostring(event));
			Events:UnregisterEvent("ITEM_PUSH");
			Events:UnregisterEvent("PLAYER_MONEY");
			Events:UnregisterEvent("UPDATE_INVENTORY_DURABILITY");
		end
	elseif (event == "ITEM_PUSH") then
		print("In new items");
		isPurchase = true;
		--UpdateMoney();
	elseif (event == "CHAT_MSG_SYSTEM") then
		--[[print("IN SYSTEM");
		print("Is Quest? '"..tostring(isQuest).."'");]]
		local msg = select(1,...);
		local isQuestReward = {};
		isQuestReward[1] = string.find(msg,"Received");
		isQuestReward[2] = string.find(msg,"Gold");
		isQuestReward[3] = string.find(msg,"Silver");
		isQuestReward[4] = string.find(msg,"Copper");
		--[[print("Message: '"..msg.."'");
		print("Line #1: '"..tostring(isQuestReward[1]).."'");
		print("Line #2: '"..tostring(isQuestReward[2]).."'");
		print("Line #3: '"..tostring(isQuestReward[3]).."'");
		print("Line #4: '"..tostring(isQuestReward[4]).."'");]]
		
		if (isQuest and isQuestReward[1] ~= nil and (isQuestReward[2] ~= nil or isQuestReward[3] ~= nil or isQuestReward[4] ~= nil)) then
			--print("IS QUEST");
			UpdateMoney(false);
		else
			--print("IS NOT QUEST");
		end
		--FindMoney(select(1,...));
		--print("1. "..select(1,...));
		--print("2. "..select(2,...));
		--FindMoney();
	end
	if (event == "CHAT_MSG_MONEY") then
		--print("IN MONEY!");
	end
end)

SLASH_GTRADDON1 = '/gtr';
function SlashCmdList.GTRADDON(msg, editbox)
	GoldDialog:Show();
	if (msg == '' or msg == 'help') then
		--DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFFFF  --WoW Bets--\n/wbi help - Display help information\n/wbi show - Display main game frame\n/wbi stats - Display game statistics frame");
	elseif (msg == "toggle") then
		if (GoldDialog:IsShown()) then
			GoldDialog:Hide();
			ArchiveDialog:Hide();
		else
			GoldDialog:Show();
		end
	elseif (msg == "show" or msg == "open") then
		GoldDialog:Show();
	elseif (msg == "hide" or msg == "close") then
		GoldDialog:Hide();
		ArchiveDialog:Hide();
	end
end